# Window Struct Reference

Data structure for an opened window. More...

`#include <window_gui.h>`

Inheritance diagram for Window:

## Public Types
enum | EventState { ES_HANDLED, ES_NOT_HANDLED }
| State whether an event is handled or not. More...
## Public Member Functions
| Window ()
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
FORCEINLINE void * | operator new[] (size_t size)
| Helper allocation function to disallow something.
FORCEINLINE void | operator delete (void *ptr)
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (uint widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
template<class NWID >
NWID * | GetWidget (uint widnum)
| Get the nested widget with number widnum from the nested widget tree.
void | InitNested (const WindowDesc *desc, WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree (const WindowDesc *desc, bool fill_nested=true)
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (const WindowDesc *desc, WindowNumber window_number)
| Perform the second part of the initialization of a nested widget tree.
void | SetWidgetDisabledState (byte widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (byte widget_index)
| Sets a widget to disabled.
void | EnableWidget (byte widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (byte widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (byte widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (byte widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (byte widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (byte widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (byte widget_index)
| Marks a widget as lowered.
void | RaiseWidget (byte widget_index)
| Marks a widget as raised.
bool | IsWidgetLowered (byte widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (byte widget_index)
| Set focus within this window to the given widget.
void | HandleButtonClick (byte widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
void CDECL | SetWidgetsDisabledState (bool disab_stat, int widgets,...)
| Sets the enabled/disabled status of a list of widgets.
void CDECL | SetWidgetsLoweredState (bool lowered_stat, int widgets,...)
| Sets the lowered/raised status of a list of widgets.
void | SetWidgetDirty (byte widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (int widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
void | DeleteChildWindows (WindowClass wc=WC_INVALID) const
| Delete all children a window might have in a head-recursive manner.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint).
void | ReInit (int rx=0, int ry=0)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | InvalidateData (int data=0)
| Mark this window's data as invalid (in need of re-computing).
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized.
virtual Point | OnInitialPosition (const WindowDesc *desc, int16 sm_width, int16 sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnFocus ()
| Called when window gains focus.
virtual void | OnFocusLost ()
| Called when window looses focus.
virtual EventState | OnKeyPress (uint16 key, uint16 keycode)
| A key has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnRightClick (Point pt, int widget)
| A click with the right mouse button has been made on the window.
virtual void | OnDragDrop (Point pt, int widget)
| A dragged 'object' has been released.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnMouseOver (Point pt, int widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnTick ()
| Called once per (game) tick.
virtual void | OnHundredthTick ()
| Called once every 100 (game) ticks.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnDropdownSelect (int widget, int index)
| A dropdown option associated to this window has been selected.
virtual void | OnQueryTextFinished (char *str)
| The query window opened from this window has closed.
virtual void | OnInvalidateData (int data=0)
| Some data on this window has become invalid.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
## Data Fields
uint16 | flags4
| Window flags,.
WindowClass | window_class
| Window class.
WindowNumber | window_number
| Window number within the window class.
int | left
| x position of left edge of the window
int | top
| y position of top edge of the window
int | width
| width of the window (number of pixels to the right in x direction)
int | height
| Height of the window (number of pixels down in y direction).
Scrollbar | hscroll
| Horizontal scroll bar.
Scrollbar | vscroll
| First vertical scroll bar.
Scrollbar | vscroll2
| Second vertical scroll bar.
ResizeInfo | resize
| Resize information.
Owner | owner
| The owner of the content shown in this window. Company colour is acquired from this variable.
ViewportData * | viewport
| Pointer to viewport data, if present.
uint32 | desc_flags
| Window/widgets default flags setting.
const NWidgetCore * | nested_focus
| Currently focused nested widget, or `NULL` if no nested widget has focus.
NWidgetBase * | nested_root
| Root of the nested tree.
NWidgetBase ** | nested_array
| Array of pointers into the tree. Do not access directly, use Window::GetWidget() instead.
uint | nested_array_size
| Size of the nested array.
NWidgetStacked * | shade_select
| Selection widget (NWID_SELECTION) to use for shading the window. If `NULL`, window cannot shade.
Dimension | unshaded_size
| Last known unshaded size (only valid while shaded).
Window * | parent
| Parent window.
Window * | z_front
| The window in front of us in z-order.
Window * | z_back
| The window behind us in z-order.
## Protected Member Functions
void | InitializeData (WindowClass cls, int window_number, uint32 desc_flags)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
void | FindWindowPlacementAndResize (int def_width, int def_height)
| Resize window towards the default size.

## Detailed Description

Data structure for an opened window.

Definition at line 329 of file window_gui.h.

## Member Enumeration Documentation

enum Window::EventState

State whether an event is handled or not.

Enumerator:

  ES_HANDLED | The passed event is handled.
  ES_NOT_HANDLED | The passed event is not handled.

Definition at line 331 of file window_gui.h.

## Constructor & Destructor Documentation

Window::Window | ( |  | ) |

Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.

Definition at line 1251 of file window.cpp.

## Member Function Documentation

void Window::CreateNestedTree | ( | const WindowDesc * | desc,
|  | bool | fill_nested = `true` |
| ) |  |  |

Perform the first part of the initialization of a nested widget tree.

Construct a nested widget tree in nested_root, and optionally fill the nested_array array to provide quick access to the uninitialized widgets. This is mainly useful for setting very basic properties.

Parameters:

  | desc | Window description.
  | fill_nested | Fill the nested_array (enabling is expensive!).

Note:
  Filling the nested array requires an additional traversal through the nested widget tree, and is best performed by FinishInitNested rather than here.

Definition at line 1214 of file window.cpp.

References MakeWindowNWidgetTree(), nested_array, nested_array_size, nested_root, WindowDesc::nwid_length, and WindowDesc::nwid_parts.

Referenced by DropdownWindow::DropdownWindow(), and InitNested().

void Window::DeleteChildWindows | ( | WindowClass | wc = `WC_INVALID` | ) | const

Delete all children a window might have in a head-recursive manner.

Parameters:

  | wc | Window class of the window to remove; WC_INVALID if class does not matter

Definition at line 597 of file window.cpp.

References FindChildWindow().

Referenced by TimetableWindow::OnClick(), OrdersWindow::OnClick(), NewGRFWindow::OnClick(), TimetableWindow::OnInvalidateData(), OrdersWindow::OnInvalidateData(), and ~Window().

void Window::DisableWidget | ( | byte | widget_index | ) | `[inline]`

Sets a widget to disabled.

Parameters:

  | widget_index | index of this widget in the window

Definition at line 422 of file window_gui.h.

References SetWidgetDisabledState().

Referenced by CustomCurrencyWindow::OnClick(), NewGRFWindow::OnInvalidateData(), VehicleDetailsWindow::OnPaint(), TimetableWindow::OnPaint(), CompanyWindow::OnPaint(), AIDebugWindow::OnPaint(), and BuildRoadToolbarWindow::UpdateOptionWidgetStatus().

void Window::DrawSortButtonState | ( | int | widget,
|  | SortButtonState | state |
| ) |  |  | const

Draw a sort button's up or down arrow symbol.

Parameters:

  | widget | Sort button widget
  | state | State of sort button

Definition at line 582 of file widget.cpp.

References _dynlang, NWidgetBase::current_x, DOWNARROW, DrawString(), IsWidgetLowered(), nested_array, NWidgetBase::pos_x, NWidgetBase::pos_y, SA_CENTER, SBS_DOWN, SBS_OFF, TD_LTR, DynamicLanguages::text_dir, top, UPARROW, and WD_SORTBUTTON_ARROW_WIDTH.

Referenced by VehicleListWindow::DrawWidget(), TownDirectoryWindow::DrawWidget(), NetworkGameWindow::DrawWidget(), SaveLoadWindow::DrawWidget(), IndustryDirectoryWindow::DrawWidget(), VehicleGroupWindow::DrawWidget(), BuildVehicleWindow::DrawWidget(), BuildBridgeWindow::DrawWidget(), and NetworkContentListWindow::OnPaint().

virtual void Window::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented in AIListWindow, AISettingsWindow, AIConfigWindow, AIDebugWindow, ReplaceVehicleWindow, BuildBridgeWindow, BuildVehicleWindow, CheatWindow, CompanyFinancesWindow, SelectCompanyLiveryWindow, SelectCompanyManagerFaceWindow, CompanyWindow, BuyCompanyWindow, DepotWindow, EnginePreviewWindow, GenerateLandscapeWindow, GenerateProgressWindow, GraphLegendWindow, BaseGraphWindow, PaymentRatesGraphWindow, CompanyLeagueWindow, PerformanceRatingDetailWindow, VehicleGroupWindow, BuildIndustryWindow, IndustryDirectoryWindow, LandInfoWindow, AboutWindow, ErrmsgWindow, TooltipsWindow, QueryWindow, SaveLoadWindow, MusicTrackSelectionWindow, MusicWindow, NetworkChatWindow, NetworkContentDownloadStatusWindow, NetworkContentListWindow, NetworkGameWindow, NetworkStartServerWindow, NetworkLobbyWindow, NetworkClientListPopupWindow, NetworkClientListWindow, NetworkJoinStatusWindow, NewGRFAddWindow, NewGRFWindow, NewsWindow, MessageHistoryWindow, MessageOptionsWindow, OrdersWindow, OskWindow, BuildRailStationWindow, BuildSignalWindow, BuildRailDepotWindow, BuildRoadDepotWindow, BuildRoadStationWindow, GameOptionsWindow, GameSettingsWindow, SignListWindow, SmallMapWindow, CompanyStationsWindow, SelectStationWindow< T >, StatusBarWindow, SubsidyListWindow, ScenarioEditorLandscapeGenerationWindow, TimetableWindow, ScenarioEditorToolbarWindow, TownAuthorityWindow, TownViewWindow, TownDirectoryWindow, TransparenciesWindow, BuildTreesWindow, RefitWindow, VehicleListWindow, VehicleDetailsWindow, VehicleViewWindow, and DropdownWindow.

Definition at line 586 of file window_gui.h.

Referenced by NWidgetLeaf::Draw(), and NWidgetBackground::Draw().

void Window::EnableWidget | ( | byte | widget_index | ) | `[inline]`

Sets a widget to Enabled.

Parameters:

  | widget_index | index of this widget in the window

Definition at line 431 of file window_gui.h.

References SetWidgetDisabledState().

Referenced by CustomCurrencyWindow::OnClick(), and TimetableWindow::OnPaint().

void Window::FindWindowPlacementAndResize | ( | int | def_width,
|  | int | def_height |
| ) |  |  | `[protected]`

Resize window towards the default size.

Prior to construction, a position for the new window (for its default size) has been found with LocalGetWindowPlacement(). Initially, the window is constructed with minimal size. Resizing the window to its default size is done here.

Parameters:

  | def_width | default width in pixels of the window
  | def_height | default height in pixels of the window

See also:
  Window::Window(), Window::InitializeData(), Window::InitializePositionSize()

Definition at line 937 of file window.cpp.

References FindWindowById(), height, ViewPort::left, left, max(), min(), OnResize(), resize, ResizeWindow(), SetDirty(), ResizeInfo::step_height, ResizeInfo::step_width, ViewPort::top, top, viewport, and width.

Referenced by FinishInitNested().

void Window::FinishInitNested | ( | const WindowDesc * | desc,
|  | WindowNumber | window_number |
| ) |  |  |

Perform the second part of the initialization of a nested widget tree.

Parameters:

  | desc | Window description.
  | window_number | Number of the new window.

Definition at line 1231 of file window.cpp.

References WindowDesc::cls, WindowDesc::default_height, WindowDesc::default_width, FindWindowPlacementAndResize(), WindowDesc::flags, InitializeData(), InitializePositionSize(), nested_root, OnInitialPosition(), and NWidgetBase::smallest_x.

Referenced by DropdownWindow::DropdownWindow(), and InitNested().

template<class NWID >

NWID * Window::GetWidget | ( | uint | widnum | ) | `[inline]`

Get the nested widget with number widnum from the nested widget tree.

Template Parameters:

  | NWID | Type of the nested widget.

Parameters:

  | widnum | Widget number of the widget to retrieve.

Returns:
  The requested widget if it is instantiated, `NULL` otherwise.

Definition at line 781 of file window_gui.h.

References nested_array, and nested_array_size.

template<class NWID >

const NWID * Window::GetWidget | ( | uint | widnum | ) | const`[inline]`

Specialized case of Window::GetWidget for the nested widget base class.

Get the nested widget with number widnum from the nested widget tree.

Template Parameters:

  | NWID | Type of the nested widget.

Parameters:

  | widnum | Widget number of the widget to retrieve.

Returns:
  The requested widget if it is instantiated, `NULL` otherwise.

Definition at line 803 of file window_gui.h.

Referenced by NWidgetLeaf::FindScrollbar(), NWidgetBackground::FindScrollbar(), Scrollbar::SetCapacityFromWidget(), and ShowDropDownList().

void Window::HandleButtonClick | ( | byte | widget | ) |

Do all things to make a button look clicked and mark it to be unclicked in a few ticks.

Parameters:

  | widget | the widget to "click"

Definition at line 241 of file window.cpp.

References flags4, LowerWidget(), SetWidgetDirty(), and WF_TIMEOUT_BEGIN.

Referenced by DispatchLeftClickEvent(), FoundTownWindow::OnClick(), ScenarioEditorLandscapeGenerationWindow::OnClick(), SmallMapWindow::OnClick(), NetworkStartServerWindow::OnClick(), BuildIndustryWindow::OnClick(), CreateScenarioWindow::OnClick(), GenerateLandscapeWindow::OnClick(), DepotWindow::OnDragDrop(), and SaveLoadWindow::OnKeyPress().

void Window::InitializeData | ( | WindowClass | cls,
|  | int | window_number,
|  | uint32 | desc_flags |
| ) |  |  | `[protected]`

Initializes the data (except the position and initial size) of a new Window.

Parameters:

  | cls | Class of the window, used for identification and grouping.

See also:
  WindowClass

Parameters:

  | window_number | Number being assigned to the new window
  | desc_flags | Window flags.

See also:
  WindowDefaultFlag

Returns:
  Window pointer of the newly created window

Precondition:
  If nested widgets are used (widget is `NULL`), nested_root and nested_array_size must be initialized. In addition, nested_array is either `NULL`, or already initialized.

Definition at line 840 of file window.cpp.

References _dynlang, NWidgetBase::AssignSizePosition(), EditBoxInGlobalFocus(), FindWindowByClass(), FindWindowById(), flags4, NWidgetBase::GetWidgetOfType(), INVALID_OWNER, nested_array, nested_array_size, nested_focus, nested_root, OnInit(), owner, resize, NWidgetBase::resize_x, NWidgetBase::resize_y, SetFocusedWindow(), NWidgetBase::SetupSmallestSize(), NWidgetBase::smallest_x, ST_SMALLEST, ResizeInfo::step_height, ResizeInfo::step_width, TD_RTL, DynamicLanguages::text_dir, window_class, WWT_EDITBOX, z_back, and z_front.

Referenced by FinishInitNested().

void Window::InitializePositionSize | ( | int | x,
|  | int | y,
|  | int | sm_width,
|  | int | sm_height |
| ) |  |  | `[protected]`

Set the position and smallest size of the window.

Parameters:

  | x | Offset in pixels from the left of the screen of the new window.
  | y | Offset in pixels from the top of the screen of the new window.
  | sm_width | Smallest width in pixels of the window.
  | sm_height | Smallest height in pixels of the window.

Definition at line 919 of file window.cpp.

References height, left, top, and width.

Referenced by FinishInitNested().

void Window::InitNested | ( | const WindowDesc * | desc,
|  | WindowNumber | window_number = `0` |
| ) |  |  |

Perform complete initialization of the Window with nested widgets, to allow use.

Parameters:

  | desc | Window description.
  | window_number | Number of the new window.

Definition at line 1244 of file window.cpp.

References CreateNestedTree(), and FinishInitNested().

Referenced by MessageHistoryWindow::MessageHistoryWindow(), NetworkContentDownloadStatusWindow::NetworkContentDownloadStatusWindow(), NetworkContentListWindow::NetworkContentListWindow(), SetDateWindow::SetDateWindow(), and VehicleDetailsWindow::VehicleDetailsWindow().

void Window::InvalidateData | ( | int | data = `0` | ) | `[inline]`

Mark this window's data as invalid (in need of re-computing).

Parameters:

  | data | The data to invalidate with

Definition at line 550 of file window_gui.h.

References OnInvalidateData(), and SetDirty().

Referenced by ChangeVehicleWindow(), InvalidateWindowClassesData(), InvalidateWindowData(), NetworkContentListWindow::NetworkContentListWindow(), GameDifficultyWindow::OnClick(), BuildSignalWindow::OnClick(), MessageOptionsWindow::OnClick(), NewGRFWindow::OnClick(), NewGRFAddWindow::OnClick(), NetworkContentListWindow::OnClick(), AIConfigWindow::OnClick(), NetworkContentListWindow::OnConnect(), NetworkContentListWindow::OnDownloadComplete(), MessageOptionsWindow::OnDropdownSelect(), NewGRFWindow::OnDropdownSelect(), NewGRFAddWindow::OnKeyPress(), NetworkContentListWindow::OnKeyPress(), NetworkChatWindow::OnKeyPress(), QueryStringWindow::OnKeyPress(), NewGRFWindow::OnQueryTextFinished(), NetworkContentListWindow::OnReceiveContentInfo(), and GameOptionsWindow::SetMediaSet().

bool Window::IsWidgetDisabled | ( | byte | widget_index | ) | const`[inline]`

Gets the enabled/disabled status of a widget.

Parameters:

  | widget_index | index of this widget in the window

Returns:
  status of the widget ie: disabled = true, enabled = false

Definition at line 441 of file window_gui.h.

References nested_array_size.

Referenced by BuildRailClick_Remove(), BuildRoadClick_OneWay(), PerformanceRatingDetailWindow::DrawWidget(), HandlePlacePushButton(), MainToolbarWindow::OnClick(), NetworkLobbyWindow::OnClick(), NetworkGameWindow::OnClick(), PerformanceRatingDetailWindow::OnClick(), AIDebugWindow::OnClick(), DepotWindow::OnDragDrop(), DepotWindow::OnTimeout(), RailToolbar_CtrlChanged(), and RoadToolbar_CtrlChanged().

bool Window::IsWidgetFocused | ( | byte | widget_index | ) | const`[inline]`

Check if given widget is focused within this window.

Parameters:

  | widget_index | : index of the widget in the window to check

Returns:
  true if given widget is the focused window in this window

Definition at line 452 of file window_gui.h.

References NWidgetCore::index, and nested_focus.

Referenced by IsWidgetGloballyFocused(), and NetworkContentListWindow::OnKeyPress().

bool Window::IsWidgetGloballyFocused | ( | byte | widget_index | ) | const`[inline]`

Check if given widget has user input focus.

This means that both the window has focus and that the given widget has focus within the window.

Parameters:

  | widget_index | : index of the widget in the window to check

Returns:
  true if given widget is the focused window in this window and this window has focus

Definition at line 463 of file window_gui.h.

References IsWidgetFocused().

bool Window::IsWidgetLowered | ( | byte | widget_index | ) | const`[inline]`

Gets the lowered state of a widget.

Parameters:

  | widget_index | index of this widget in the window

Returns:
  status of the widget ie: lowered = true, raised= false

Definition at line 513 of file window_gui.h.

References nested_array_size.

Referenced by BuildRailClick_Remove(), BuildSignalWindow::DrawSignalSprite(), DrawSortButtonState(), PaymentRatesGraphWindow::DrawWidget(), HandlePlacePushButton(), DepotWindow::OnClick(), OrdersWindow::OnMouseLoop(), DepotWindow::OnMouseLoop(), ScenarioEditorLandscapeGenerationWindow::OnPaint(), VehicleGroupWindow::OnPaint(), BuildRailToolbarWindow::OnPlaceDrag(), BuildRailToolbarWindow::OnPlaceMouseUp(), BuildRoadToolbarWindow::OnPlaceObject(), ScenarioEditorToolbarWindow::OnTick(), MainToolbarWindow::OnTick(), MainToolbarWindow::OnTimeout(), ScenarioEditorLandscapeGenerationWindow::OnTimeout(), OrdersWindow::OnTimeout(), NetworkStartServerWindow::OnTimeout(), SaveLoadWindow::OnTimeout(), CreateScenarioWindow::OnTimeout(), GenerateLandscapeWindow::OnTimeout(), OrdersWindow::OrderClick_Goto(), RailToolbar_CtrlChanged(), RaiseButtons(), RoadToolbar_CtrlChanged(), ToggleRailButton_Remove(), ToggleRoadButton_Remove(), and BuildRoadToolbarWindow::UpdateOptionWidgetStatus().

void Window::LowerWidget | ( | byte | widget_index | ) | `[inline]`

Marks a widget as lowered.

Parameters:

  | widget_index | index of this widget in the window

Definition at line 494 of file window_gui.h.

References SetWidgetLoweredState().

Referenced by BuildRailStationWindow::CheckSelectedSize(), HandleButtonClick(), HandlePlacePushButton(), BuildTreesWindow::OnClick(), SmallMapWindow::OnClick(), GameDifficultyWindow::OnClick(), BuildRoadStationWindow::OnClick(), BuildRoadDepotWindow::OnClick(), BuildRailDepotWindow::OnClick(), BuildRailStationWindow::OnClick(), PerformanceRatingDetailWindow::OnClick(), BuildDocksDepotWindow::OnClick(), BuildDocksStationWindow::OnClick(), CompanyWindow::OnClick(), SelectCompanyLiveryWindow::OnClick(), BuildSignalWindow::OnInvalidateData(), PerformanceRatingDetailWindow::OnInvalidateData(), AIDebugWindow::OnPaint(), OrdersWindow::OrderClick_Conditional(), ShowDropDownList(), and OskWindow::UpdateOskState().

virtual void Window::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented in AIListWindow, AISettingsWindow, AIConfigWindow, AIDebugWindow, BuildAirToolbarWindow, AirportPickerWindow, ReplaceVehicleWindow, BuildBridgeWindow, BuildVehicleWindow, CheatWindow, CompanyFinancesWindow, SelectCompanyLiveryWindow, SelectCompanyManagerFaceWindow, CompanyWindow, BuyCompanyWindow, SetDateWindow, DepotWindow, BuildDocksToolbarWindow, BuildDocksStationWindow, BuildDocksDepotWindow, EnginePreviewWindow, GenerateLandscapeWindow, CreateScenarioWindow, GenerateProgressWindow, GraphLegendWindow, BaseGraphWindow, PerformanceHistoryGraphWindow, PaymentRatesGraphWindow, PerformanceRatingDetailWindow, VehicleGroupWindow, EndGameHighScoreBaseWindow, BuildIndustryWindow, IndustryViewWindow, IndustryDirectoryWindow, SelectGameWindow, QueryStringWindow, QueryWindow, SaveLoadWindow, MusicTrackSelectionWindow, MusicWindow, NetworkChatWindow, NetworkContentDownloadStatusWindow, NetworkContentListWindow, NetworkGameWindow, NetworkStartServerWindow, NetworkLobbyWindow, NetworkClientListWindow, NetworkJoinStatusWindow, NetworkCompanyPasswordWindow, NewGRFAddWindow, NewGRFWindow, NewsWindow, MessageHistoryWindow, MessageOptionsWindow, OrdersWindow, OskWindow, BuildRailToolbarWindow, BuildRailStationWindow, BuildSignalWindow, BuildRailDepotWindow, BuildRailWaypointWindow, BuildRoadToolbarWindow, BuildRoadDepotWindow, BuildRoadStationWindow, GameOptionsWindow, GameDifficultyWindow, GameSettingsWindow, CustomCurrencyWindow, SignListWindow, SignWindow, SmallMapWindow, CompanyStationsWindow, StationViewWindow, SelectStationWindow< T >, StatusBarWindow, SubsidyListWindow, TerraformToolbarWindow, ScenarioEditorLandscapeGenerationWindow, TimetableWindow, MainToolbarWindow, ScenarioEditorToolbarWindow, TownAuthorityWindow, TownViewWindow, TownDirectoryWindow, FoundTownWindow, TransparenciesWindow, BuildTreesWindow, RefitWindow, VehicleListWindow, VehicleDetailsWindow, VehicleViewWindow, ExtraViewportWindow, WaypointWindow, and DropdownWindow.

Definition at line 643 of file window_gui.h.

Referenced by DispatchLeftClickEvent(), and OskWindow::OnClick().

virtual EventState Window::OnCTRLStateChange | ( |  | ) | `[inline, virtual]`

The state of the control key has changed.

Returns:
  ES_HANDLED if the change has been handled and no other window should receive the event.

Reimplemented in DepotWindow, BuildRailToolbarWindow, and BuildRoadToolbarWindow.

Definition at line 634 of file window_gui.h.

References ES_NOT_HANDLED.

Referenced by HandleCtrlChanged().

virtual void Window::OnDragDrop | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A dragged 'object' has been released.

Parameters:

  | pt | the point inside the window where the release took place.
  | widget | the widget where the release took place.

Reimplemented in DepotWindow, VehicleGroupWindow, and OrdersWindow.

Definition at line 657 of file window_gui.h.

virtual void Window::OnDropdownSelect | ( | int | widget,
|  | int | index |
| ) |  |  | `[inline, virtual]`

A dropdown option associated to this window has been selected.

Parameters:

  | widget | the widget (button) that the dropdown is associated with.
  | index | the element in the dropdown that is selected.

Reimplemented in ReplaceVehicleWindow, BuildBridgeWindow, BuildVehicleWindow, SelectCompanyLiveryWindow, SetDateWindow, GenerateLandscapeWindow, CreateScenarioWindow, VehicleGroupWindow, IndustryDirectoryWindow, NetworkGameWindow, NetworkStartServerWindow, NewGRFWindow, MessageOptionsWindow, OrdersWindow, BuildRailStationWindow, GameOptionsWindow, CompanyStationsWindow, MainToolbarWindow, ScenarioEditorToolbarWindow, and VehicleListWindow.

Definition at line 712 of file window_gui.h.

Referenced by DropdownWindow::OnMouseLoop().

virtual void Window::OnInit | ( |  | ) | `[inline, virtual]`

Notification that the nested widget tree gets initialized.

The event can be used to perform general computations.

Note:
  nested_root and/or nested_array (normally accessed via GetWidget()) may not exist during this call.

Reimplemented in SelectCompanyManagerFaceWindow, MessageOptionsWindow, and SmallMapWindow.

Definition at line 562 of file window_gui.h.

Referenced by InitializeData(), and ReInit().

Point Window::OnInitialPosition | ( | const WindowDesc * | desc,
|  | int16 | sm_width,
|  | int16 | sm_height,
|  | int | window_number |
| ) |  |  | `[virtual]`

Compute the initial position of the window.

Parameters:

  | *desc | The pointer to the WindowDesc of the window to create.
  | sm_width | Smallest width of the window.
  | sm_height | Smallest height of the window.
  | window_number | The window number of the new window.

Returns:
  Initial position of the top-left corner of the window.

Reimplemented in SetDateWindow, ErrmsgWindow, TooltipsWindow, NetworkChatWindow, NetworkClientListPopupWindow, NewsWindow, StatusBarWindow, TerraformToolbarWindow, TransparenciesWindow, and DropdownWindow.

Definition at line 1201 of file window.cpp.

References LocalGetWindowPlacement().

Referenced by FinishInitNested().

virtual void Window::OnInvalidateData | ( | int | data = `0` | ) | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | information about the changed data.

Reimplemented in AIConfigWindow, AIDebugWindow, AirportPickerWindow, ReplaceVehicleWindow, BuildVehicleWindow, SelectCompanyLiveryWindow, DepotWindow, GraphLegendWindow, BaseGraphWindow, PaymentRatesGraphWindow, CompanyLeagueWindow, PerformanceRatingDetailWindow, VehicleGroupWindow, BuildIndustryWindow, IndustryDirectoryWindow, MainWindow, ErrmsgWindow, SaveLoadWindow, MusicTrackSelectionWindow, MusicWindow, NetworkChatWindow, NetworkContentListWindow, NetworkGameWindow, NewGRFAddWindow, NewGRFWindow, NewsWindow, MessageHistoryWindow, MessageOptionsWindow, OrdersWindow, OskWindow, BuildSignalWindow, GameOptionsWindow, GameDifficultyWindow, SignListWindow, CompanyStationsWindow, SelectStationWindow< T >, StatusBarWindow, SubsidyListWindow, TimetableWindow, MainToolbarWindow, ScenarioEditorToolbarWindow, TownViewWindow, TownDirectoryWindow, FoundTownWindow, TransparenciesWindow, BuildTreesWindow, VehicleListWindow, VehicleDetailsWindow, ExtraViewportWindow, and WaypointWindow.

Definition at line 726 of file window_gui.h.

Referenced by InvalidateData().

virtual EventState Window::OnKeyPress | ( | uint16 | key,
|  | uint16 | keycode |
| ) |  |  | `[inline, virtual]`

A key has been pressed.

Parameters:

  | key | the Unicode value of the key.
  | keycode | the untranslated key code including shift state.

Returns:
  ES_HANDLED if the key press has been handled and no other window should receive the event.

Reimplemented in BuildAirToolbarWindow, BuildBridgeWindow, IConsoleWindow, BuildDocksToolbarWindow, GenerateLandscapeWindow, EndGameHighScoreBaseWindow, MainWindow, ErrmsgWindow, QueryStringWindow, QueryWindow, SaveLoadWindow, NetworkChatWindow, NetworkContentListWindow, NetworkGameWindow, NetworkStartServerWindow, NetworkCompanyPasswordWindow, NewGRFAddWindow, NewsWindow, OrdersWindow, BuildRailToolbarWindow, BuildRoadToolbarWindow, SignWindow, TerraformToolbarWindow, ScenarioEditorLandscapeGenerationWindow, MainToolbarWindow, ScenarioEditorToolbarWindow, and FoundTownWindow.

Definition at line 627 of file window_gui.h.

References ES_NOT_HANDLED.

Referenced by HandleKeypress().

virtual void Window::OnMouseOver | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

The mouse is currently moving over the window or has just moved outside of the window.

In the latter case pt is (-1, -1).

Parameters:

  | pt | the point inside the window that the mouse hovers over.
  | widget | the widget the mouse hovers over.

Reimplemented in NetworkClientListWindow.

Definition at line 671 of file window_gui.h.

virtual void Window::OnMouseWheel | ( | int | wheel | ) | `[inline, virtual]`

The mouse wheel has been turned.

Parameters:

  | wheel | the amount of movement of the mouse wheel.

Reimplemented in MainWindow, SmallMapWindow, and ExtraViewportWindow.

Definition at line 677 of file window_gui.h.

virtual void Window::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented in AIListWindow, AISettingsWindow, AIConfigWindow, AIDebugWindow, BuildAirToolbarWindow, AirportPickerWindow, ReplaceVehicleWindow, BuildBridgeWindow, BuildVehicleWindow, CheatWindow, CompanyFinancesWindow, SelectCompanyLiveryWindow, SelectCompanyManagerFaceWindow, CompanyWindow, BuyCompanyWindow, IConsoleWindow, SetDateWindow, DepotWindow, BuildDocksToolbarWindow, BuildDocksStationWindow, BuildDocksDepotWindow, EnginePreviewWindow, GenerateLandscapeWindow, CreateScenarioWindow, GenerateProgressWindow, GraphLegendWindow, BaseGraphWindow, CompanyLeagueWindow, PerformanceRatingDetailWindow, VehicleGroupWindow, EndGameWindow, HighScoreWindow, BuildIndustryWindow, IndustryViewWindow, IndustryDirectoryWindow, SelectGameWindow, MainWindow, LandInfoWindow, AboutWindow, ErrmsgWindow, TooltipsWindow, QueryStringWindow, QueryWindow, SaveLoadWindow, MusicTrackSelectionWindow, MusicWindow, NetworkChatWindow, NetworkContentDownloadStatusWindow, NetworkContentListWindow, NetworkGameWindow, NetworkStartServerWindow, NetworkLobbyWindow, NetworkClientListPopupWindow, NetworkClientListWindow, NetworkJoinStatusWindow, NetworkCompanyPasswordWindow, NewGRFAddWindow, NewGRFWindow, NewsWindow, MessageHistoryWindow, MessageOptionsWindow, OrdersWindow, OskWindow, BuildRailToolbarWindow, BuildRailStationWindow, BuildSignalWindow, BuildRailDepotWindow, BuildRailWaypointWindow, BuildRoadToolbarWindow, BuildRoadDepotWindow, BuildRoadStationWindow, GameOptionsWindow, GameDifficultyWindow, GameSettingsWindow, CustomCurrencyWindow, SignListWindow, SignWindow, SmallMapWindow, CompanyStationsWindow, StationViewWindow, SelectStationWindow< T >, StatusBarWindow, SubsidyListWindow, TerraformToolbarWindow, ScenarioEditorLandscapeGenerationWindow, TimetableWindow, MainToolbarWindow, ScenarioEditorToolbarWindow, TownAuthorityWindow, TownViewWindow, TownDirectoryWindow, FoundTownWindow, TransparenciesWindow, BuildTreesWindow, RefitWindow, VehicleListWindow, VehicleDetailsWindow, VehicleViewWindow, ExtraViewportWindow, WaypointWindow, and DropdownWindow.

Definition at line 578 of file window_gui.h.

Referenced by DrawOverlappedWindow().

virtual void Window::OnPlaceDrag | ( | ViewportPlaceMethod | select_method,
|  | ViewportDragDropSelectionProcess | select_proc,
|  | Point | pt |
| ) |  |  | `[inline, virtual]`

The user is dragging over the map when the tile highlight mode has been set.

Parameters:

  | select_method | the method of selection (allowed directions)
  | select_proc | what will be created when the drag is over.
  | pt | the exact point on the map where the mouse is.

Reimplemented in BuildAirToolbarWindow, BuildDocksToolbarWindow, BuildRailToolbarWindow, BuildRoadToolbarWindow, TerraformToolbarWindow, ScenarioEditorLandscapeGenerationWindow, and BuildTreesWindow.

Definition at line 750 of file window_gui.h.

Referenced by VpHandlePlaceSizingDrag().

virtual void Window::OnPlaceMouseUp | ( | ViewportPlaceMethod | select_method,
|  | ViewportDragDropSelectionProcess | select_proc,
|  | Point | pt,
|  | TileIndex | start_tile,
|  | TileIndex | end_tile |
| ) |  |  | `[inline, virtual]`

The user has dragged over the map when the tile highlight mode has been set.

Parameters:

  | select_method | the method of selection (allowed directions)
  | select_proc | what should be created.
  | pt | the exact point on the map where the mouse was released.
  | start_tile | the begin tile of the drag.
  | end_tile | the end tile of the drag.

Reimplemented in BuildAirToolbarWindow, BuildDocksToolbarWindow, BuildRailToolbarWindow, BuildRoadToolbarWindow, TerraformToolbarWindow, ScenarioEditorLandscapeGenerationWindow, and BuildTreesWindow.

Definition at line 761 of file window_gui.h.

Referenced by VpHandlePlaceSizingDrag().

virtual void Window::OnPlaceObject | ( | Point | pt,
|  | TileIndex | tile |
| ) |  |  | `[inline, virtual]`

The user clicked some place on the map when a tile highlight mode has been set.

Parameters:

  | pt | the exact point on the map that has been clicked.
  | tile | the tile on the map that has been clicked.

Reimplemented in BuildAirToolbarWindow, CompanyWindow, DepotWindow, BuildDocksToolbarWindow, BuildIndustryWindow, OrdersWindow, BuildRailToolbarWindow, BuildRoadToolbarWindow, TerraformToolbarWindow, ScenarioEditorLandscapeGenerationWindow, MainToolbarWindow, ScenarioEditorToolbarWindow, FoundTownWindow, and BuildTreesWindow.

Definition at line 735 of file window_gui.h.

virtual void Window::OnPlacePresize | ( | Point | pt,
|  | TileIndex | tile |
| ) |  |  | `[inline, virtual]`

The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.

An example of this is the tile highlight for dock building.

Parameters:

  | pt | the exact point on the map where the mouse is.
  | tile | the tile on the map where the mouse is.

Reimplemented in BuildDocksToolbarWindow, BuildRailToolbarWindow, and BuildRoadToolbarWindow.

Definition at line 770 of file window_gui.h.

virtual void Window::OnQueryTextFinished | ( | char * | str | ) | `[inline, virtual]`

The query window opened from this window has closed.

Parameters:

  | str | the new value of the string, NULL if the window was cancelled or an empty string when the default button was pressed, i.e. StrEmpty(str).

Reimplemented in AISettingsWindow, BuildVehicleWindow, SelectCompanyManagerFaceWindow, CompanyWindow, GenerateLandscapeWindow, CreateScenarioWindow, VehicleGroupWindow, IndustryViewWindow, NetworkGameWindow, NetworkStartServerWindow, NetworkJoinStatusWindow, NewGRFWindow, OrdersWindow, GameSettingsWindow, CustomCurrencyWindow, StationViewWindow, TimetableWindow, TownViewWindow, VehicleDetailsWindow, and WaypointWindow.

Definition at line 720 of file window_gui.h.

virtual void Window::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented in AIListWindow, AISettingsWindow, AIDebugWindow, ReplaceVehicleWindow, BuildBridgeWindow, BuildVehicleWindow, DepotWindow, VehicleGroupWindow, BuildIndustryWindow, IndustryViewWindow, IndustryDirectoryWindow, MainWindow, SaveLoadWindow, NetworkContentListWindow, NetworkGameWindow, NetworkLobbyWindow, NewGRFAddWindow, NewGRFWindow, MessageHistoryWindow, OrdersWindow, GameSettingsWindow, SignListWindow, CompanyStationsWindow, StationViewWindow, SelectStationWindow< T >, SubsidyListWindow, TimetableWindow, TownViewWindow, TownDirectoryWindow, RefitWindow, VehicleListWindow, VehicleDetailsWindow, VehicleViewWindow, ExtraViewportWindow, and WaypointWindow.

Definition at line 705 of file window_gui.h.

Referenced by FindWindowPlacementAndResize(), and ResizeWindow().

virtual void Window::OnRightClick | ( | Point | pt,
|  | int | widget |
| ) |  |  | `[inline, virtual]`

A click with the right mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.

Reimplemented in DepotWindow, and SmallMapWindow.

Definition at line 650 of file window_gui.h.

Referenced by DispatchRightClickEvent().

virtual void Window::OnScroll | ( | Point | delta | ) | `[inline, virtual]`

Handle the request for (viewport) scrolling.

Parameters:

  | delta | the amount the viewport must be scrolled.

Reimplemented in MainWindow, SmallMapWindow, and ExtraViewportWindow.

Definition at line 663 of file window_gui.h.

FORCEINLINE void Window::operator delete | ( | void * | ptr | ) | `[inline]`

Helper allocation function to disallow something.

Don't free the window directly; it corrupts the linked list when iterating

Parameters:

  | ptr | the pointer not to free

Reimplemented from ZeroedMemoryAllocator.

Definition at line 362 of file window_gui.h.

FORCEINLINE void* Window::operator new[] | ( | size_t | size | ) | `[inline]`

Helper allocation function to disallow something.

Don't allow arrays; arrays of Windows are pointless as you need to destruct them all at the same time too, which is kinda hard.

Parameters:

  | size | the amount of space not to allocate

Reimplemented from ZeroedMemoryAllocator.

Definition at line 352 of file window_gui.h.

void Window::RaiseButtons | ( | bool | autoraise = `false` | ) |

Raise the buttons of the window.

Parameters:

  | autoraise | Raise only the push buttons of the window.

Definition at line 213 of file window.cpp.

References IsWidgetLowered(), nested_array, nested_array_size, RaiseWidget(), SetWidgetDirty(), and WWT_LAST.

Referenced by BuildIndustryWindow::OnClick(), CompanyWindow::OnPlaceObject(), BuildTreesWindow::OnPlaceObjectAbort(), FoundTownWindow::OnPlaceObjectAbort(), ScenarioEditorLandscapeGenerationWindow::OnPlaceObjectAbort(), TerraformToolbarWindow::OnPlaceObjectAbort(), BuildRoadToolbarWindow::OnPlaceObjectAbort(), BuildIndustryWindow::OnPlaceObjectAbort(), BuildDocksToolbarWindow::OnPlaceObjectAbort(), CompanyWindow::OnPlaceObjectAbort(), BuildAirToolbarWindow::OnPlaceObjectAbort(), and BuildIndustryWindow::OnTimeout().

void Window::RaiseWidget | ( | byte | widget_index | ) | `[inline]`

Marks a widget as raised.

Parameters:

  | widget_index | index of this widget in the window

Definition at line 503 of file window_gui.h.

References SetWidgetLoweredState().

Referenced by BuildRailStationWindow::CheckSelectedSize(), SmallMapWindow::OnClick(), GameDifficultyWindow::OnClick(), BuildRoadStationWindow::OnClick(), BuildRoadDepotWindow::OnClick(), BuildRailDepotWindow::OnClick(), BuildSignalWindow::OnClick(), BuildRailStationWindow::OnClick(), SelectGameWindow::OnClick(), PerformanceRatingDetailWindow::OnClick(), CreateScenarioWindow::OnClick(), GenerateLandscapeWindow::OnClick(), BuildDocksDepotWindow::OnClick(), BuildDocksStationWindow::OnClick(), SelectCompanyLiveryWindow::OnClick(), PerformanceRatingDetailWindow::OnInvalidateData(), GraphLegendWindow::OnInvalidateData(), VehicleGroupWindow::OnPaint(), AIDebugWindow::OnPaint(), OrdersWindow::OnPlaceObjectAbort(), DepotWindow::OnPlaceObjectAbort(), BuildTreesWindow::OnTimeout(), FoundTownWindow::OnTimeout(), MainToolbarWindow::OnTimeout(), ScenarioEditorLandscapeGenerationWindow::OnTimeout(), OrdersWindow::OnTimeout(), NetworkStartServerWindow::OnTimeout(), CreateScenarioWindow::OnTimeout(), GenerateLandscapeWindow::OnTimeout(), DepotWindow::OnTimeout(), AIDebugWindow::OnTimeout(), RaiseButtons(), ResetSignalVariant(), and BuildRoadToolbarWindow::UpdateOptionWidgetStatus().

void Window::ReInit | ( | int | rx = `0`,
|  | int | ry = `0` |
| ) |  |  |

Re-initialize a window, and optionally change its size.

Parameters:

  | rx | Horizontal resize of the window.
  | ry | Vertical resize of the window.

Note:
  For just resizing the window, use ResizeWindow instead.

Definition at line 523 of file window.cpp.

References _dynlang, NWidgetBase::AssignSizePosition(), height, max(), nested_root, OnInit(), resize, NWidgetBase::resize_x, NWidgetBase::resize_y, ResizeWindow(), SetDirty(), NWidgetBase::SetupSmallestSize(), NWidgetBase::smallest_x, NWidgetBase::smallest_y, ST_SMALLEST, ResizeInfo::step_height, ResizeInfo::step_width, TD_RTL, DynamicLanguages::text_dir, and width.

Referenced by BuildRailToolbarWindow::ModifyRailType(), StationViewWindow::OnClick(), SelectCompanyManagerFaceWindow::OnClick(), SelectCompanyLiveryWindow::OnClick(), CompanyFinancesWindow::OnClick(), CompanyFinancesWindow::OnHundredthTick(), VehicleDetailsWindow::OnInvalidateData(), TimetableWindow::OnInvalidateData(), SelectCompanyLiveryWindow::OnInvalidateData(), StationViewWindow::OnPaint(), IndustryViewWindow::OnPaint(), CompanyFinancesWindow::OnPaint(), BuildVehicleWindow::OnPaint(), ReInitAllWindows(), and SetShaded().

bool Window::SetFocusedWidget | ( | byte | widget_index | ) |

Set focus within this window to the given widget.

The function however doesn't change which window has focus.

Parameters:

  | widget_index | Index of the widget in the window to set the focus to.

Returns:
  Focus has changed.

Definition at line 153 of file window.cpp.

References nested_array, nested_array_size, nested_focus, and NWidgetBase::SetDirty().

Referenced by DispatchLeftClickEvent(), NetworkContentListWindow::NetworkContentListWindow(), FoundTownWindow::OnClick(), and OskWindow::OnClick().

void Window::SetShaded | ( | bool | make_shaded | ) |

Set the shaded state of the window to make_shaded.

Parameters:

  | make_shaded | If `true`, shade the window (roll up until just the title bar is visible), else unshade/unroll the window to its original size.

Note:
  The method uses Window::ReInit(), thus after the call, the whole window should be considered changed.

Definition at line 558 of file window.cpp.

References height, ReInit(), NWidgetStacked::SetDisplayedPlane(), shade_select, NWidgetStacked::shown_plane, SZSP_HORIZONTAL, unshaded_size, and width.

Referenced by BringWindowToFrontById(), DispatchLeftClickEvent(), DispatchMouseWheelEvent(), and CompanyFinancesWindow::OnClick().

virtual void Window::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented in AIConfigWindow, AIDebugWindow, ReplaceVehicleWindow, BuildVehicleWindow, CompanyFinancesWindow, SelectCompanyLiveryWindow, CompanyWindow, BuyCompanyWindow, SetDateWindow, DepotWindow, GenerateLandscapeWindow, CreateScenarioWindow, VehicleGroupWindow, BuildIndustryWindow, IndustryViewWindow, IndustryDirectoryWindow, SelectGameWindow, AboutWindow, ErrmsgWindow, QueryStringWindow, QueryWindow, MusicTrackSelectionWindow, NetworkGameWindow, NetworkStartServerWindow, NetworkLobbyWindow, NewGRFWindow, NewsWindow, OrdersWindow, OskWindow, BuildRailToolbarWindow, BuildRailStationWindow, BuildSignalWindow, GameOptionsWindow, GameDifficultyWindow, CustomCurrencyWindow, SignListWindow, SignWindow, SmallMapWindow, CompanyStationsWindow, StationViewWindow, TimetableWindow, TownAuthorityWindow, TownViewWindow, TownDirectoryWindow, RefitWindow, VehicleListWindow, VehicleDetailsWindow, VehicleViewWindow, ExtraViewportWindow, and WaypointWindow.

Definition at line 608 of file window_gui.h.

Referenced by NWidgetLeaf::Draw(), NWidgetBackground::Draw(), NWidgetLeaf::SetupSmallestSize(), and NWidgetBackground::SetupSmallestSize().

void Window::SetWidgetDirty | ( | byte | widget_index | ) | const

Invalidate a widget, i.e.

mark it as being changed and in need of redraw.

Parameters:

  | widget_index | the widget to redraw.

Definition at line 228 of file window.cpp.

References nested_array, and NWidgetBase::SetDirty().

Referenced by IndustryDirectoryWindow::BuildSortIndustriesList(), HandleButtonClick(), HandleZoomMessage(), TransparenciesWindow::OnClick(), MusicWindow::OnClick(), SaveLoadWindow::OnClick(), DepotWindow::OnClick(), CompanyWindow::OnClick(), DepotWindow::OnCTRLStateChange(), SignListWindow::OnInvalidateData(), OskWindow::OnInvalidateData(), OskWindow::OnMouseLoop(), AIDebugWindow::OnPaint(), BuildRoadToolbarWindow::OnPlaceObjectAbort(), OrdersWindow::OnPlaceObjectAbort(), VehicleGroupWindow::OnPlaceObjectAbort(), DepotWindow::OnPlaceObjectAbort(), NetworkStartServerWindow::OnQueryTextFinished(), CreateScenarioWindow::OnQueryTextFinished(), GenerateLandscapeWindow::OnQueryTextFinished(), MainToolbarWindow::OnTick(), StatusBarWindow::OnTick(), BuildTreesWindow::OnTimeout(), ScenarioEditorToolbarWindow::OnTimeout(), MainToolbarWindow::OnTimeout(), ScenarioEditorLandscapeGenerationWindow::OnTimeout(), OrdersWindow::OnTimeout(), NetworkStartServerWindow::OnTimeout(), CreateScenarioWindow::OnTimeout(), GenerateLandscapeWindow::OnTimeout(), DepotWindow::OnTimeout(), OrdersWindow::OrderClick_Conditional(), OrdersWindow::OrderClick_Goto(), OrdersWindow::OrderClick_Nonstop(), RaiseButtons(), SetWindowWidgetDirty(), ShowDropDownList(), BuildBridgeWindow::SortBridgeList(), CompanyStationsWindow::SortStationsList(), ToggleRailButton_Remove(), ToggleRoadButton_Remove(), and BuildRoadToolbarWindow::UpdateOptionWidgetStatus().

void Window::SetWidgetDisabledState | ( | byte | widget_index,
|  | bool | disab_stat |
| ) |  |  | `[inline]`

Sets the enabled/disabled status of a widget.

By default, widgets are enabled. On certain conditions, they have to be disabled.

Parameters:

  | widget_index | index of this widget in the window
  | disab_stat | status to use ie: disabled = true, enabled = false

Definition at line 412 of file window_gui.h.

References nested_array, and nested_array_size.

Referenced by DisableWidget(), EnableWidget(), HandleZoomMessage(), BuildIndustryWindow::OnClick(), WaypointWindow::OnInvalidateData(), GameDifficultyWindow::OnInvalidateData(), BuildSignalWindow::OnInvalidateData(), NewGRFWindow::OnInvalidateData(), NewGRFAddWindow::OnInvalidateData(), NetworkContentListWindow::OnInvalidateData(), MusicTrackSelectionWindow::OnInvalidateData(), BuildIndustryWindow::OnInvalidateData(), PerformanceRatingDetailWindow::OnInvalidateData(), AirportPickerWindow::OnInvalidateData(), AIConfigWindow::OnInvalidateData(), VehicleDetailsWindow::OnPaint(), VehicleListWindow::OnPaint(), TownAuthorityWindow::OnPaint(), ScenarioEditorToolbarWindow::OnPaint(), MainToolbarWindow::OnPaint(), TimetableWindow::OnPaint(), StationViewWindow::OnPaint(), BuildRailStationWindow::OnPaint(), NetworkLobbyWindow::OnPaint(), NetworkGameWindow::OnPaint(), CreateScenarioWindow::OnPaint(), GenerateLandscapeWindow::OnPaint(), CompanyWindow::OnPaint(), SelectCompanyLiveryWindow::OnPaint(), CompanyFinancesWindow::OnPaint(), BuildIndustryWindow::OnTick(), MessageOptionsWindow::SetMessageButtonStates(), SetWidgetsDisabledState(), SmallMapWindow::SetZoomLevel(), BuildRoadToolbarWindow::UpdateOptionWidgetStatus(), and OskWindow::UpdateOskState().

void Window::SetWidgetLoweredState | ( | byte | widget_index,
|  | bool | lowered_stat |
| ) |  |  | `[inline]`

Sets the lowered/raised status of a widget.

Parameters:

  | widget_index | index of this widget in the window
  | lowered_stat | status to use ie: lowered = true, raised = false

Definition at line 473 of file window_gui.h.

References nested_array_size.

Referenced by LowerWidget(), FoundTownWindow::OnClick(), SmallMapWindow::OnClick(), GameOptionsWindow::OnClick(), BuildRailStationWindow::OnClick(), MusicWindow::OnClick(), AirportPickerWindow::OnClick(), TransparenciesWindow::OnInvalidateData(), GameOptionsWindow::OnInvalidateData(), BuildSignalWindow::OnInvalidateData(), MessageOptionsWindow::OnInvalidateData(), MusicWindow::OnInvalidateData(), MusicTrackSelectionWindow::OnInvalidateData(), TimetableWindow::OnPaint(), BuildRailWaypointWindow::OnPaint(), CreateScenarioWindow::OnPaint(), GenerateLandscapeWindow::OnPaint(), SelectCompanyManagerFaceWindow::OnPaint(), RaiseWidget(), SetWidgetsLoweredState(), and OskWindow::UpdateOskState().

void CDECL Window::SetWidgetsDisabledState | ( | bool | disab_stat,
|  | int | widgets,
|  |  | ... |
| ) |  |  |

Sets the enabled/disabled status of a list of widgets.

By default, widgets are enabled. On certain conditions, they have to be disabled.

Parameters:

  | disab_stat | status to use ie: disabled = true, enabled = false
  | widgets | list of widgets ended by WIDGET_LIST_END

Definition at line 176 of file window.cpp.

References SetWidgetDisabledState(), and WIDGET_LIST_END.

Referenced by VehicleDetailsWindow::OnClick(), NewGRFWindow::OnInvalidateData(), VehicleDetailsWindow::OnPaint(), VehicleListWindow::OnPaint(), MainToolbarWindow::OnPaint(), VehicleGroupWindow::OnPaint(), GenerateLandscapeWindow::OnPaint(), BuildDocksToolbarWindow::OnPaint(), DepotWindow::OnPaint(), SelectCompanyManagerFaceWindow::OnPaint(), AIDebugWindow::OnPaint(), BuildRoadToolbarWindow::OnPlaceObjectAbort(), and BuildRoadToolbarWindow::UpdateOptionWidgetStatus().

void CDECL Window::SetWidgetsLoweredState | ( | bool | lowered_stat,
|  | int | widgets,
|  |  | ... |
| ) |  |  |

Sets the lowered/raised status of a list of widgets.

Parameters:

  | lowered_stat | status to use ie: lowered = true, raised = false
  | widgets | list of widgets ended by WIDGET_LIST_END

Definition at line 195 of file window.cpp.

References SetWidgetLoweredState(), and WIDGET_LIST_END.

Referenced by SelectCompanyManagerFaceWindow::OnPaint(), ScenarioEditorToolbarWindow::OnTimeout(), and BuildRoadToolbarWindow::UpdateOptionWidgetStatus().

void Window::ToggleWidgetLoweredState | ( | byte | widget_index | ) | `[inline]`

Invert the lowered/raised status of a widget.

Parameters:

  | widget_index | index of this widget in the window

Definition at line 483 of file window_gui.h.

References nested_array_size.

Referenced by BuildRoadClick_OneWay(), BuildRailStationWindow::OnClick(), NetworkCompanyPasswordWindow::OnClick(), PaymentRatesGraphWindow::OnClick(), GraphLegendWindow::OnClick(), DepotWindow::OnClick(), ScenarioEditorToolbarWindow::OnTick(), MainToolbarWindow::OnTick(), OrdersWindow::OrderClick_Goto(), ToggleRailButton_Remove(), and ToggleRoadButton_Remove().

void Window::UnfocusFocusedWidget | ( |  | ) |

Makes no widget on this window have focus.

The function however doesn't change which window has focus.

Definition at line 139 of file window.cpp.

References nested_focus, and NWidgetBase::SetDirty().

Referenced by FoundTownWindow::OnKeyPress().

virtual void Window::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented in AIListWindow, AISettingsWindow, AIConfigWindow, AIDebugWindow, ReplaceVehicleWindow, BuildBridgeWindow, BuildVehicleWindow, CheatWindow, CompanyFinancesWindow, SelectCompanyLiveryWindow, SelectCompanyManagerFaceWindow, CompanyWindow, BuyCompanyWindow, SetDateWindow, DepotWindow, EnginePreviewWindow, GenerateLandscapeWindow, CreateScenarioWindow, GenerateProgressWindow, BaseGraphWindow, PaymentRatesGraphWindow, CompanyLeagueWindow, PerformanceRatingDetailWindow, VehicleGroupWindow, BuildIndustryWindow, IndustryViewWindow, IndustryDirectoryWindow, SelectGameWindow, LandInfoWindow, AboutWindow, ErrmsgWindow, TooltipsWindow, QueryStringWindow, QueryWindow, SaveLoadWindow, MusicTrackSelectionWindow, MusicWindow, NetworkChatWindow, NetworkContentListWindow, NetworkGameWindow, NetworkStartServerWindow, NetworkLobbyWindow, NetworkClientListPopupWindow, NetworkClientListWindow, NetworkJoinStatusWindow, NewGRFAddWindow, NewGRFWindow, NewsWindow, MessageHistoryWindow, MessageOptionsWindow, OrdersWindow, BuildRailStationWindow, GameOptionsWindow, GameDifficultyWindow, GameSettingsWindow, CustomCurrencyWindow, SignListWindow, CompanyStationsWindow, StationViewWindow, SelectStationWindow< T >, StatusBarWindow, SubsidyListWindow, TimetableWindow, ScenarioEditorToolbarWindow, TownAuthorityWindow, TownViewWindow, TownDirectoryWindow, BuildTreesWindow, RefitWindow, VehicleListWindow, VehicleDetailsWindow, and VehicleViewWindow.

Definition at line 600 of file window_gui.h.

Referenced by NWidgetLeaf::SetupSmallestSize(), NWidgetBackground::SetupSmallestSize(), and NWidgetStacked::SetupSmallestSize().

## Field Documentation

uint32 Window::desc_flags

Window/widgets default flags setting.

See also:
  WindowDefaultFlag

Definition at line 383 of file window_gui.h.

Referenced by DeleteConstructionWindows(), DispatchLeftClickEvent(), and MaybeBringWindowToFront().

uint16 Window::flags4

Window flags,.

See also:
  WindowFlags

Definition at line 366 of file window_gui.h.

Referenced by BringWindowToFrontById(), CheckSoftLimit(), DeleteAllNonVitalWindows(), DeleteNonVitalWindows(), DeleteWindowById(), DispatchLeftClickEvent(), NWidgetLeaf::Draw(), DrawWidgets(), DropdownWindow::DropdownWindow(), HandleAutoscroll(), HandleButtonClick(), InitializeData(), MaybeBringWindowToFront(), BuildTreesWindow::OnClick(), CustomCurrencyWindow::OnClick(), GameSettingsWindow::OnClick(), NetworkStartServerWindow::OnClick(), IndustryViewWindow::OnClick(), CreateScenarioWindow::OnClick(), GenerateLandscapeWindow::OnClick(), CheatWindow::OnClick(), ScrollbarClickPositioning(), StartWindowDrag(), StartWindowSizing(), and UpdateWindows().

The documentation for this struct was generated from the following files:

- src/window_gui.h
- src/viewport.cpp
- src/widget.cpp
- src/window.cpp